from sensor_oracle import best_sensor
from planning_oracle import best_plan


def pair_evaluation(gallery, path, sensor):
    """
    Method to evaluate the value of path-sensor pair

    Parameters
    ----------
    gallery: Gallery
        Map of the environment with information about sensors of a given size
    path: list(tuple(int, int))
        List of coordinates forming the path.
    sensor: int
        Index of the sensor.
    Returns
    -------
    cost: double
        Cost of the path assuming the given sensor is active.
    """

    # placeholder code you need to replace it with working evaluation
    return 0


def double_oracle(gallery, epsilon=1e-6):
    """
    Method to compute optimal strategy for attacker and defender using double oracle algorithm and oracles implemented in previous steps

    Parameters
    ----------
    gallery: Gallery
        Map of the environment with information about sensors of a given size
    epsilon: double
        The distance between both player's best response values required to terminate the algorithm
    Returns
    -------
    sensor_strategy: list(double)
        Optimal strategy as a probability distribution over sensors
    sensors: list(int)
        List of sensors used as actions
    path_strategy: list(double)
        Optimal strategy as a probability distribution over paths
    paths: list(list(tuple(int, int)))
        List of all the paths used as actions
    """

    # placeholder code you need to replace it with working double oracle
    return [1], [0], [1], best_plan(gallery, [])
